#!/usr/bin/ruby

require 'getoptlong.rb'
$VERSION = "0.01"
class MonitorsTable
  def initialize (file)
    @ids = loadtable(file)
    puts "error loading, file #{file} not found" if (!@ids)
  end
# return hash, containts all pciids from file
  def loadtable(file)
    return false if !FileTest.exists? file
    ret = Array.new
    @comments = Array.new
    File.open(file).readlines.each { |line|
      if line =~ /^#.*/
	@comments+=[line]
	next
      end
      ret += [ line ]
    }
    ret
  end
# update pcidb from file
  def update(file)
    idsnew = loadtable(file)
    puts "error update, file #{file} not found" if (!@ids)
    @ids = sync(@ids,idsnew)
  end
# sync idsold with idsnew databases
  def sync(idsold,idsnew)
    idsnew.each { |data|
      if !idsold.include?(data)
	puts "New: #{data}"
	idsold += [data]
      end
    }
    return idsold
  end
  # write db to file
  def write(file)
    f = file ? File.new(file,"w") : $stdout
    @comments.each { |data| f.puts data }
    @ids.sort{|x,y| x.downcase <=> y.downcase}.each { |data|
      f.puts data
    }
  end
  def self::help
    self::printver
    puts "Usage: mergemonitors.rb -f <source from db> -t <source from db2> [ -o <output results file> ]"
    exit(1)
  end
  def self::printver
    puts "Merge monitors database utility. (c) GNU GPL, ALT Linux, 2003. Version: #{$VERSION}"
  end
  def self::version
    self::printver
    exit(1)
  end

end

from = FALSE
to = FALSE
out = FALSE
$new = FALSE

begin 
  parser = GetoptLong.new
  parser.set_options(
		     ['--source1','-f', GetoptLong::REQUIRED_ARGUMENT],
		     ['--source2','-t', GetoptLong::REQUIRED_ARGUMENT],
		     ['--output','-o', GetoptLong::REQUIRED_ARGUMENT],
		     ['--onlynew','-n',GetoptLong::OPTIONAL_ARGUMENT],
		     ['--help',                     GetoptLong::NO_ARGUMENT],
		     ['--version',                  GetoptLong::NO_ARGUMENT])
  parser.each_option do |name, arg|
    from = arg if name == "--source1"
    to = arg if name == "--source2"
    out = arg if name == "--output"
    $new = TRUE if name == "--onlynew"
    MonitorsTable::help if name == "--help"
    MonitorsTable::help if name == "--version"
  end
  MonitorsTable::help if (!from or !to)
  p = MonitorsTable.new(from)
  p.update(to)
  p.write(out)

exit(0)
rescue
  exit(1)
end
