#!/usr/bin/ruby

require 'getoptlong.rb'
$VERSION = "0.01"

class PCITable
  def initialize (file)
    @ids = loadpcitable(file)
    puts "error loading, file #{file} not found" if (!@ids)
  end
# return hash, containts all pciids from file
  def loadpcitable(file)
    return false if !FileTest.exists? file
    ret = Hash.new
    File.open(file).readlines.each { |line|
      next if line =~ /^#/
      next if line.length == 1
      arr=line.split(/\t/)
      ret[arr[0]] = Hash.new if (ret[arr[0]].class != Hash)
      ret[arr[0]][arr[1]] = Hash.new if (ret[arr[0]][arr[1]].class != Hash)
      if (arr.length > 4)
	ret[arr[0]][arr[1]][arr[2]] = Hash.new if (ret[arr[0]][arr[1]][arr[2]].class != Hash)
	ret[arr[0]][arr[1]][arr[2]][arr[3]] = { "driver" => arr[4], "name" => arr[5] }
      else
	ret[arr[0]][arr[1]]["null"] = { "null" => { "driver" => arr[2], "name" => arr[3] } }
      end
    }
    ret
  end
# update pcidb from file
  def update(file)
    idsnew = loadpcitable(file)
    puts "error update, file #{file} not found" if (!@ids)
    @ids = sync(@ids,idsnew)
  end
# sync idsold with idsnew databases
  def sync(idsold,idsnew)
    idsnew.each { |vendor,value|
      value.each { |device, svs|
	svs.each { |subv, svds|
	  svds.each { |subd, data|
	    if (!idsold[vendor] or !idsold[vendor][device] or !idsold[vendor][device][subv] or !idsold[vendor][device][subv][subd])
	      puts "#{vendor}\t#{device}\t#{data['driver']}\t#{data['name']}"
	      idsold[vendor] = Hash.new if (idsold[vendor].class != Hash)
	      idsold[vendor][device] = Hash.new if (idsold[vendor][device].class != Hash)
	      idsold[vendor][device][subv] = Hash.new if (idsold[vendor][device][subv].class != Hash)
	      idsold[vendor][device][subv][subd] = data
	    else
	      if (idsold[vendor][device][subv][subd]['driver'] != data['driver'] and !$new)
	        if (idsold[vendor][device][subv][subd]['driver'] == "\"unknown\"" or data['driver'] != "\"unknown\"")
		  
		  print(idsold[vendor][device][subv][subd]['driver']!="\"unknown\""?"Update - please test":"Update")
		  
		  puts ":#{vendor}\t#{device}\t#{idsold[vendor][device][subv][subd]['driver']}=>#{data['driver']} for #{ idsold[vendor][device][subv][subd]['name']}"
		  idsold[vendor][device][subv][subd] = data
		end
	      end
	    end
	  }
	}
      }
    }
    idsold
  end
  # write db to file
  def write(file)
    f = file ? File.new(file,"w") : $stdout 
    @ids.sort.each { |vendor,value|
      value.sort.each { |device,svs|
	svs.sort.each { |subv, svds|
	  svds.sort.each { |subd, data|
	    if (subv == "null")
	      f.puts "#{vendor}\t#{device}\t#{data['driver']}\t#{data['name']}"
	    else
	      f.puts "#{vendor}\t#{device}\t#{subv}\t#{subd}\t#{data['driver']}\t#{data['name']}"
	    end
	  }
	}
      }
    }
  end
  def self::help
    puts "Merge hardware databases utility. (c) GNU GPL, ALT Linux, 2003. Version: #{$VERSION}"
    puts "Usage: mergepcitables.rb  -f <source1 pcitable> -t <source2 pcitable> [ -o <output results file> ]"
    exit(1)
  end
  def self::version
    puts "Merge hardware databases utility. (c) GNU GPL,  ALT Linux, 2003. Version: #{$VERSION}"
    exit(1)
  end
end

from = FALSE
to = FALSE
out = FALSE
$new = FALSE

begin 
  parser = GetoptLong.new
  parser.set_options(
		     ['--source1','-f', GetoptLong::REQUIRED_ARGUMENT],
		     ['--source2','-t', GetoptLong::REQUIRED_ARGUMENT],
		     ['--output','-o', GetoptLong::REQUIRED_ARGUMENT],
		     ['--onlynew','-n',GetoptLong::OPTIONAL_ARGUMENT],
		     ['--help','-h',GetoptLong::NO_ARGUMENT],
		     ['--version','-v',GetoptLong::NO_ARGUMENT])
  parser.each_option do |name, arg|
    from = arg if name == "--source1"
    to = arg if name == "--source2"
    out = arg if name == "--output"
    $new = TRUE if name == "--onlynew"
    PCITable::help if name == "--help"
    PCITable::help if name == "--version"
  end
  PCITable::help if (!from or !to)
  p = PCITable.new(from)
  p.update(to)
  p.write(out)

exit(0)
rescue
  exit(1)
end
